
{$X+}
{$S-}
program ListDemo;

uses
  Dos,Drivers,Objects,Views,Menus,Dialogs,StdDlg,MsgBox,App,Editors,Printer,
  Memory,Crt;

const
  cmOpen            = 100;
  cmprint           = 101;
  hcOpen            = 102;
  MaxWordLen        = 45;
  LineLength        = 80;
  NoteLen  = 3000;  { Length of memo field }

  So       : String[4] = #00^N;
  EmpOn    : String[4] = ^['E';
  EmpOff   : String[4] = ^['F';
  ItalOn   : String[4] = #27'4';
  ItalOff  : String[4] = #27'5';

type
  PMemoData     = ^TMemoData;
  PListApp = ^TListApp;
  TListApp = object (TApplication)
    procedure HandleEvent (var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    end;

  PItemColl = ^TItemColl;
  TItemColl = object(TStringCollection)
    constructor Init;
  end;

  PGroceryList = ^TGroceryList;
  TGroceryList = object(TMemo)
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

  PGroceryDialog = ^TGroceryDialog;
  TGroceryDialog = object (TDialog)
    GroceryList: PGroceryList;
    procedure HandleEvent (var Event: TEvent); virtual;
    end;

var
  Item:PItemColl;
  S: String[30];


constructor TItemColl.Init;
begin
  inherited Init(10, 10);
  Insert(NewStr('Butter'));
  Insert(NewStr('Detergent'));
  Insert(NewStr('Eggs'));
  Insert(NewStr('Flour'));
  Insert(NewStr('Margarine'));
  Insert(NewStr('Meal'));
  Insert(NewStr('Soda'));
  Insert(NewStr('Sugar'));
  Insert(NewStr('Water'));
  Insert(NewStr('Milk'));
  Insert(NewStr('Bread'));
  Insert(NewStr('Cheese'));
  Insert(NewStr('Paper towels'));
  Insert(NewStr('Orange juice'));
  Insert(NewStr('Doughtnuts'));
  Insert(NewStr('Coffee'));
  Insert(NewStr('Tea'));
  Insert(NewStr('Apple juice'));
end;



procedure Show1;

var
  D : PGroceryDialog;
  R : Trect;
  W    : Word;
  I    : PInputLine;
  S    : String[MaxWordLen];
  L    : PListBox;
  Scrollbar : PScrollBar;
  Control: PView;

begin
Item:= New(PItemColl,Init);
  R.Assign(10,0,70,22);
  D := New(PGroceryDialog, Init(R, 'Shopping list'));
  with D^ do
  begin
  R.Assign(8, 1, 21, 2);
  Insert(New(PLabel, Init(R, 'Grocery list', Control)));
  R.Assign(3, 2, 30, 16);
  GroceryList := New(PGroceryList, Init(R,NIL,NIL,NIL, 1000));
  Insert(GroceryList);
  R.Assign(42, 1, 50, 2);
  Insert(New(PLabel, Init(R, 'Items', Control)));
  R.Assign(55, 2, 56, 16);
  New(ScrollBar, Init(R));
  Insert(ScrollBar);
  R.Assign(35, 2, 55, 16);
  Control := New(PListBox, Init(R, 1, ScrollBar));
  Insert(Control);
  PListBox(Control)^.NewList(Item);
  R.Assign(30,19,40,21);
  insert(new(pbutton, init(r, '~P~rint', cmprint, bfnormal)));
  R.Assign(15,19,25,21);
  Insert(New(PButton, Init(R, '~C~ancel', cmcancel, bfdefault)));
  SelectNext(False);
  end;
  W := DeskTop^.ExecView(D);
    Dispose(D,done);
  end;


procedure PrintMemo(P: PMemoData);

var
  I: Word;


begin
if P^.Length <> 0 then
  for I := 0 to P^.Length - 1 do write(Lst,EmpOn+ItalOn,P^.Buffer[I]+EmpOff+ItalOff);
end;


procedure TGroceryDialog.HandleEvent (var Event: TEvent);

var
  P: PMemoData;
  ExtractedNames: String;
  ExtractedStars: String;
  Dialog  : PDialog;
  R       : Trect;
  Control : Word;

begin
inherited HandleEvent (Event);
if (Event.What = evCommand) and (Event.Command = cmPrint) then
  begin
  R.Assign(0, 0, 35, 7);
  Dialog := New(PDialog, Init(R, ''));
  Dialog^.Flags := 0;
  with dialog^ do
  begin
    Options := Options or ofCentered;
    R.Assign(5, 2, 26 ,3);
    Insert(New(PStaticText, Init(R, ^C'Printing Grocery list')));
    R.Assign(7, 4, 23, 5);
    Insert(New(PStaticText, Init(R, ^C'Please wait')));
  end;
  Application^.Insert(Dialog);
  ExtractedNames := 'Grocery List  ';
  Writeln(Lst,So+EmpOn+ExtractedNames+EmpOff);
  ExtractedStars := '************';
  WriteLn(Lst,So+EmpOn+ExtractedStars+EmpOff);
  writeln(lst);
  GetMem (P,NoteLen + SizeOf (P^.Length));
  GroceryList^.GetData (P^);
  PrintMemo(P);
  writeln(Lst, #12);
  FreeMem (P,NoteLen + SizeOf (P^.Length));
  ClearEvent (Event);
  Application^.Delete(Dialog);
  Dispose(Dialog, Done);
end;
end;


procedure TListApp.HandleEvent (var Event: TEvent);


begin
TApplication.HandleEvent (Event);
if Event.What = evCommand then
  begin
  case Event.Command of
    cmOpen: Show1;
    else Exit;
    end;
  ClearEvent(Event);
  end;
end;



procedure TGroceryList.HandleEvent(var Event: TEvent);
VAR
  Count:Integer;
begin
  inherited HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.command=cmListItemSelected) then
    begin
      S:=PListBox(Event.InfoPtr)^.GetText(PListBox(Event.InfoPtr)^.Focused,
                                          high(s));
      with PListBox(Event.InfoPtr)^ do
      begin
        s := s + #13 + #10;
        InsertText(@s[1],length(s),false);
      end;
      DrawView;
      ClearEvent(Event);
    end;
end;

procedure TListApp.InitMenuBar;

var
  R: TRect;

begin
GetExtent (R);
R.B.Y := R.A.Y + 1;
MenuBar := New (PMenuBar,Init (R,NewMenu (
  NewSubMenu ('~F~ile',hcnocontext,NewMenu (
    NewItem ('~O~pen file...','',kbnokey,cmOpen,hcnocontext,
    NewLine (
    NewItem ('E~x~it','Alt-X',kbAltX,cmQuit,hcnocontext,nil)))),nil))));
end;

procedure TListApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R,
  NewStatusDef(0, 0,
  NewStatusKey('~F1~ Help', kbf1, cmhelp,
  NewStatusKey('', kbf10, cmmenu,
  NewStatusKey('   ~Esc~ Cancel', kbesc, cmClose,
  NewStatusKey('   ~Alt-F3~ Close', kbaltf3, cmClose,
  NewStatusKey('   ~Alt-X~ Exit', kbaltx, cmQuit,
  Nil))))),
  NewStatusDef(1, $ffff,
  NewStatusKey('~F1~ Help', kbf1, cmhelp,
  Nil),
  Nil))));

end;

var
  ListApp: TListApp;

begin
ListApp.Init;
ListApp.Run;
ListApp.Done;
end.
